/*
 *======================================================================
 *
 *Copyright 1992 Sun Microsystems, Inc.
 *
 *The Interface Definition Language Compiler Front End (CFE) is made
 *available for use provided that this legend is included on all media and
 *documentation and as a part of the software program in whole or part.
 *Users may copy and extend functionality (but may not remove
 *functionality) of the Interface Definition Language CFE without charge,
 *but are not authorized to license or distribute it to anyone else except
 *as part of a product or program developed by the user or with the express
 *written consent of Sun Microsystems, Inc.
 *
 *The names of Sun Microsystems, Inc. and any of its subsidiaries may not
 *be used in advertising or publicity pertaining to distribution of
 *Interface Definition Language CFE as permitted herein.
 *
 *The Interface Definition Language CFE may not be exported outside the
 *United States without first obtaining the appropriate government
 *approvals.
 *
 *INTERFACE DEFINITION LANGUAGE CFE IS PROVIDED AS IS WITH NO WARRANTIES
 *OF ANY KIND INCLUDING THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND
 *FITNESS FOR A PARTICULAR PURPOSE, NONINFRINGEMENT, OR ARISING FROM A
 *COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 *Interface Definition Language CFE is provided with no support and
 *without any obligation on the part of Sun Microsystems, Inc. or any of
 *its subsidiaries or affiliates to assist in its use, correction,
 *modification or enhancement.
 *
 *SUN MICROSYSTEMS, INC. OR ANY OF ITS SUBSIDIARIES OR AFFILIATES SHALL
 *HAVE NO LIABILITY WITH RESPECT TO THE INFRINGEMENT OF COPYRIGHTS, TRADE
 *SECRETS OR ANY PATENTS BY INTERFACE DEFINITION LANGUAGE CFE OR ANY PART
 *THEREOF.
 *
 *IN NO EVENT WILL SUN MICROSYSTEMS, INC. OR ANY OF ITS SUBSIDIARIES OR
 *AFFILIATES BE LIABLE FOR ANY LOST REVENUE OR PROFITS OR OTHER SPECIAL,
 *INDIRECT AND CONSEQUENTIAL DAMAGES, EVEN IF SUN HAS BEEN ADVISED OF THE
 *POSSIBILITY OF SUCH DAMAGES.
 *
 *SunSoft, Inc.  
 *2550 Garcia Avenue 
 *Mountain View, California  94043
 *
 *
 *
 *
 *======================================================================
 */

#pragma ident "%@(#)DRV_init.cc	1.16% %92/06/10% Sun Microsystems"

// DRV_init.cc - Initialization for IDL compiler driver program

#include	<idl.hh>
#include	<idl_extern.hh>

#include	<drv_private.hh>

void
DRV_init()
{
  // Initialize global data

  idl_global = new IDL_GlobalData();

  idl_global->set_scopes(NULL);
  idl_global->set_root(NULL);
  idl_global->set_gen(NULL);
  idl_global->set_err(new UTL_Error());
  idl_global->set_err_count(0);
  idl_global->set_indent(new UTL_Indenter());

  idl_global->set_filename(NULL);
  idl_global->set_main_filename(NULL);
  idl_global->set_in_main_file(FALSE);
  idl_global->set_lineno(-1);

  idl_global->set_prog_name(NULL);

  idl_global->set_cpp_location(CPP_LOCATION);

  idl_global->set_be("");

  idl_global->set_local_escapes(new char[1024]);

  idl_global->set_pragmas(NULL);

  idl_global->set_compile_flags(0);

  idl_global->set_read_from_stdin(FALSE);

  idl_global->set_include_file_names(NULL);
  idl_global->set_n_include_file_names(0);

  idl_global->set_parse_state(IDL_GlobalData::PS_NoState);

  // Initialize driver private data

  DRV_nfiles = 0;
  DRV_file_index = 0;  
}

